//
// Written by Sander van Rossen
//	You are free to use this piece of code any way you like
//
#pragma once




/*!
	@brief		Declare an alias named <tAliasName> for the type <tTypeName>
*/
#define DECLARE_ALIAS(tTypeName, tAliasName)					\
	typedef		  tTypeName				tAliasName;				\
//endof DECLARE_ALIAS(inType, outType)





/*!
	@brief		Declare the base hungarian names for <tTypeName>
*/
#define DECLARE_HUNGARIAN(tTypeName)							\
	typedef		  tTypeName	  &			r##tTypeName;			\
	typedef		  tTypeName*			p##tTypeName;			\
	typedef		  tTypeName*const		cp##tTypeName;			\
	typedef		  tTypeName*const&		rcp##tTypeName;			\
	typedef	const tTypeName				c##tTypeName;			\
	typedef	const tTypeName	  &			rc##tTypeName;			\
	typedef	const tTypeName*			pc##tTypeName;			\
	typedef	const tTypeName*const		cpc##tTypeName;			\
	typedef	const tTypeName*const&		rcpc##tTypeName;		\
//endof DECLARE_HUNGARIAN(inType)




DECLARE_ALIAS(unsigned char, UChar);	// Create UChar alias for unsigned chars
DECLARE_ALIAS(unsigned int,  UInt);		// Create UInt alias for unsigned ints
DECLARE_HUNGARIAN(UChar);				// Declare all hungarian names for UChar
DECLARE_HUNGARIAN(UInt);				// Declare all hungarian names for UInt